summaryrefslogtreecommitdiffstats
path: root/development/qb64pe
diff options
context:
space:
mode:
Diffstat (limited to 'development/qb64pe')
-rw-r--r--development/qb64pe/README21
-rw-r--r--development/qb64pe/doinst.sh13
-rw-r--r--development/qb64pe/qb64pe-launcher24
-rw-r--r--development/qb64pe/qb64pe.156
-rw-r--r--development/qb64pe/qb64pe.SlackBuild91
-rw-r--r--development/qb64pe/qb64pe.desktop9
-rw-r--r--development/qb64pe/qb64pe.info10
-rw-r--r--development/qb64pe/qb64pe.pngbin0 -> 17438 bytes
-rw-r--r--development/qb64pe/slack-desc19
9 files changed, 243 insertions, 0 deletions
diff --git a/development/qb64pe/README b/development/qb64pe/README
new file mode 100644
index 0000000000..36f4d8acfc
--- /dev/null
+++ b/development/qb64pe/README
@@ -0,0 +1,21 @@
+QB64 Phoenix Edition (QB64-PE) is a fork of QB64.com, providing
+additional features and enhancements, maintained by a
+group of original developers of QB64.com.
+
+QB64-PE is a modern extended BASIC programming language with embedded
+OpenGL support that retains QuickBASIC 4.5 and QBasic compatibility
+and compiles native binaries for Windows (Vista and up),
+Linux and macOS.
+
+Unlike traditional BASIC and QBasic code, QB64pe gets compiled
+automatically into machine code – allowing exceptional performance,
+easy distribution, and the ability to link with external C and C++
+programming libaries. Compatible with most QBasic 4.5 code, QB64pe
+adds a number of extensions, such as OpenGL and other modern
+features, providing the perfect blend of classic and modern
+program development.
+
+On first run this package installs ~/.config/qb64pe-(version)
+in $HOME in order to run the program and its data.
+You can delete this directory and rebuild you local configuration
+by relaunching the program.
diff --git a/development/qb64pe/doinst.sh b/development/qb64pe/doinst.sh
new file mode 100644
index 0000000000..aea0f894eb
--- /dev/null
+++ b/development/qb64pe/doinst.sh
@@ -0,0 +1,13 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
+if [ -x /usr/bin/update-mime-database ]; then
+ /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ /usr/bin/gtk-update-icon-cache -f usr/share/icons/hicolor >/dev/null 2>&1
+ fi
+fi
diff --git a/development/qb64pe/qb64pe-launcher b/development/qb64pe/qb64pe-launcher
new file mode 100644
index 0000000000..8729180619
--- /dev/null
+++ b/development/qb64pe/qb64pe-launcher
@@ -0,0 +1,24 @@
+#!/bin/sh
+
+VERSION=3.12.0
+DEST="$HOME/.config/qb64pe-$VERSION"
+if [ ! -d $DEST ]
+then
+ notify-send "Setting up $DEST workspace for first run, please be patient..."
+ CWD=`pwd`
+ mkdir -p $DEST
+ cd $DEST
+ tar xvfz /usr/src/qb64pe-$VERSION/QB64pe-$VERSION.tar.gz --strip-components=1
+ make clean OS=lnx
+ make OS=lnx BUILD_QB64=y -j1
+ rm -rf run_qb64pe.sh
+ ln -s /usr/bin/qb64pe-launcher run_qb64pe.sh
+ rm -rf .ci
+ rm -rf .github
+ rm -rf .gitignore
+ rm -rf .clang-format
+ rm -rf setup_*
+ rm -rf qb64pe.1
+ cd $CWD
+fi
+$DEST/qb64pe "$@" &
diff --git a/development/qb64pe/qb64pe.1 b/development/qb64pe/qb64pe.1
new file mode 100644
index 0000000000..69764a72c5
--- /dev/null
+++ b/development/qb64pe/qb64pe.1
@@ -0,0 +1,56 @@
+.TH qb64pe "1" "August 2022" "QB64 IDE AND COMPILER (Phoenix Edition)" "User Commands"
+.SH NAME
+qb64pe \- manual page for QB64-PE
+.SH DESCRIPTION
+QB64 COMPILER (Phoenix Edition)
+.PP
+USAGE: qb64pe [switches] <file>
+.SS "OPTIONS:"
+.TP
+<file>
+Source file to load
+.TP
+\fB\-v\fR
+Print version number and exit
+.TP
+\fB\-c\fR
+Compile instead of edit
+.TP
+\fB\-x\fR
+Compile instead of edit and output the result to the
+console
+.TP
+\fB\-p\fR
+Purge all pre\-compiled content first
+.TP
+\fB\-z\fR
+Generate C code without compiling to executable
+.TP
+\fB\-o\fR <output file>
+Write output executable to <output file>
+.TP
+\fB\-w\fR
+Show warnings when compiling
+.TP
+\fB\-q\fR
+Quiet mode (suppresses most output other than warnings and errors)
+.TP
+\fB\-m\fR
+Suppress colors in output
+.TP
+\fB\-e\fR
+Enables OPTION _EXPLICIT, making variable declaration
+mandatory (per\-compilation; doesn't affect the
+source file or global settings)
+.TP
+\fB\-s[\fR:switch=true/false]
+View/edit compiler settings
+.TP
+\fB\-f[\fR:setting=value]
+Configure compiler settings for this run of the compiler
+.TP
+\fB\-l\fR:<line number>
+Starts the IDE at the specified line number
+.PP
+.SH "INTERNET"
+.B https://qb64phoenix.com
diff --git a/development/qb64pe/qb64pe.SlackBuild b/development/qb64pe/qb64pe.SlackBuild
new file mode 100644
index 0000000000..4beaac60e4
--- /dev/null
+++ b/development/qb64pe/qb64pe.SlackBuild
@@ -0,0 +1,91 @@
+#!/bin/bash
+
+# Slackware build script for qb64pe (from qb64phoenix.com)
+
+# Copyright 2024 Antonio Leal, Porto Salvo, Oeiras, Portugal
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=qb64pe
+VERSION=${VERSION:-3.12.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+TARBALL=${TARBALL:-QB64pe}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+mkdir $PRGNAM-$VERSION
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p $PKG/usr/bin $PKG/usr/src/$PRGNAM-$VERSION $PKG/usr/share/pixmaps $PKG/usr/share/applications $PKG/usr/man/man1
+if [ -f "$CWD/$TARBALL-$VERSION.tar.gz" ]; then
+ cp $CWD/$TARBALL-$VERSION.tar.gz $PKG/usr/src/$PRGNAM-$VERSION/$TARBALL-$VERSION.tar.gz
+else
+ cp $CWD/$PRGNAM-$VERSION.tar.gz $PKG/usr/src/$PRGNAM-$VERSION/$TARBALL-$VERSION.tar.gz
+fi
+cat $CWD/qb64pe.1 | gzip -c -f > $PKG/usr/man/man1/qb64pe.1.gz
+cp $CWD/qb64pe-launcher $PKG/usr/bin
+chmod 755 $PKG/usr/bin/qb64pe-launcher
+cp $CWD/qb64pe.desktop $PKG/usr/share/applications
+cp $CWD/qb64pe.png $PKG/usr/share/pixmaps/qb64pe.png
+( cd $PKG/usr/bin ; rm -rf qb64pe )
+( cd $PKG/usr/bin ; ln -sf qb64pe-launcher qb64pe )
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/qb64pe/qb64pe.desktop b/development/qb64pe/qb64pe.desktop
new file mode 100644
index 0000000000..cfb8016e10
--- /dev/null
+++ b/development/qb64pe/qb64pe.desktop
@@ -0,0 +1,9 @@
+[Desktop Entry]
+Name=QB64-PE Programming IDE
+GenericName=QB64-PE Programming IDE
+Exec=qb64pe-launcher %F
+Icon=qb64pe
+Terminal=false
+Type=Application
+Categories=Development;IDE;
+StartupNotify=false
diff --git a/development/qb64pe/qb64pe.info b/development/qb64pe/qb64pe.info
new file mode 100644
index 0000000000..e0e7fe2c1a
--- /dev/null
+++ b/development/qb64pe/qb64pe.info
@@ -0,0 +1,10 @@
+PRGNAM="qb64pe"
+VERSION="3.12.0"
+HOMEPAGE="https://qb64phoenix.com/"
+DOWNLOAD="https://github.com/QB64-Phoenix-Edition/QB64pe/archive/v3.12.0/QB64pe-3.12.0.tar.gz"
+MD5SUM="f5e43d15462c169e619bc78d05d004a9"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Antonio Leal"
+EMAIL="antonioleal@yahoo.com"
diff --git a/development/qb64pe/qb64pe.png b/development/qb64pe/qb64pe.png
new file mode 100644
index 0000000000..03033cfe7d
--- /dev/null
+++ b/development/qb64pe/qb64pe.png
Binary files differ
diff --git a/development/qb64pe/slack-desc b/development/qb64pe/slack-desc
new file mode 100644
index 0000000000..f505d85726
--- /dev/null
+++ b/development/qb64pe/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+qb64pe: qb64pe (Modern QuickBASIC compiler)
+qb64pe:
+qb64pe: QB64 Phoenix Edition (QB64-PE) is a fork of QB64.com, providing
+qb64pe: additional features and enhancements, maintained by a
+qb64pe: group of original developers of QB64.com.
+qb64pe:
+qb64pe: QB64-PE is a modern extended BASIC programming language with embedded
+qb64pe: OpenGL support that retains QuickBASIC 4.5 and QBasic compatibility
+qb64pe: and compiles native binaries for Windows (Vista and up),
+qb64pe: Linux and macOS.
+qb64pe: Homepage https://qb64phoenix.com/